# ZionBuilder PRO Plugin

Built and designed by [Hogash team](https://hogash.com),
the creator of famous WordPress theme [Kallyas](https://kallyas.net/),
this plugin is the newest page builder on the market that comes with tools to build an outstanding WordPress website.

**Tags:** page builder, WordPress module, editor, visual editor, design, website builder, front-end builder

## Description
Below are listed the core competencies

### Elements and templates at your fingertip
Add elements and templates right where you need them from the page builder "Add Elements Popup"

### PRO elements
* Countdown
* Social Share
* Search
* Pro Tabs ( replaces normal tabs element and adds ability to use page builder elements as content )
* Pro Accordions ( replaces normal accordions element and adds ability to use page builder elements as content )

### Key Features
* Zion Library Pro Blocks
* Header Builder ( coming soon )
* Footer Builder ( coming soon )
* Transitions
* Transform
* Upload Custom icons
* Upload Custom fonts
* Adobe Fonts
* Dynamic Content
* Global Colors
* Global Gradients
* Users Permissions

### Global styles
In order to apply the same styles on multiple elements, Global CSS Classes were implemented. They can be styled either from page options panel, or from the Element options panel. No coding skills required.


### Design features
The following extra design features come built in the Panel Element Options: Blending Bakground, ColorPicker, Pseudo – selectors, Element’s motion control, Flexbox control, Powerful background image, Filters, Borders, Shadows, Typography, Transform, Transitions

### Library system
A whole panel that can be accessed from the main bar. It contains the actions needed for import and exporting library parts, and the access to Zion library.

### Advanced features
* Post revisions
* Role Manager
* Regenerate CSS
* Replace URL
* Custom CSS
* Custom javaScript
* Renaming elements
* Element’s visibility
* Custom HTML element
* Columns sizes and offsets
* Extendable options

## Installation

### Minimum requirements
* Zion Builder Free Plugin
* WordPress 5.0 or higher
* PHP 7.0 or higher
* MySQL 5.6 or higher
* WP Memory Limit at least 64M or higher
* Writing permissions for WordPress uploads directory and `.htaccess` file
* PHP Zip extension must be installed
* PHP GD extension must be installed

### Installation
1. Install using the [WordPress built-in Plugin](https://wordpress.org/plugins/zionbuilder/)
   installer Go to Plugins -> Add New
1. Search for Zionbuilder
1. Activate the plugin
1. Go to Pages or Posts > Add New
1. Press the 'Edit with Zion Page Builder' button.

For documentation and tutorials visit our [Knowledge Base](https://zionbuilder.io/help-center/).


## An extendable builder – for developers and designers
The whole system of options, which is built in PHP, allows other developers to add their own options to the main panel.
The library system also allows designers to submit new templates which users will have access to through Zion Library.

## Documentation and Support
[Documentation link](https://zionbuilder.io/help-center/)


## Changelog ##
### 2.0.0 2021-02-26 ###
* Feature: Theme builder ( header and footer builder )
* Feature: Added invert filter to style options
* Feature: Added ability to add custom attributes to elements
* Feature: Allow selecting dynamic data source
* Feature: Woocommerce elements
* Feature: White label
* Feature: Repeater elements
* Improvement: RTL support
* Improvement: Pro license display on mobile
* Improvement: Added translate strings for dynamicContent Option
* Improvement: Updated plugin structure to support integrations
* Fixed custom code not loading element file
* Fixed missing pro label to custom code
* Fixed templates sortable not working
* Fixed custom icons preview modal
* Fixed title on social share element
### 1.2.1 2020-12-08 ###
* Fixed custom classes not applying on socialShare, search and accordion elements
### 1.2.0 2020-12-07 ###
* Added Custom PHP
* Automatically refresh the page after inserting the API key
### 1.1.1 2020-11-27 ###
* Hotfix for lifetime license

### 1.1.0- 2020-11-24 ###
* Fixed various issues related to global colors/gradients
* Fixed icons list not adding to tabs
* Updated tabs to zb 1.1.0
* Add loader when delete license key
* Removed utils
* Register elements with the new system
* Re-organize code structure
* Updated dependencies
* Updated folder structure
* Update to vue 3 and fix syntax compatibility
* Fixed text domain used for elements
### 1.0.1- 2020-09-26 ###
* Hotfix for typeKit

### 1.0.0- 2020-08-19 ###
* Initial Public Release
